`timescale 1 ns / 1 ps

module picorv32_smem (
    clk,
    mem_valid, 
    mem_ready, 
    mem_addr, 
    mem_wdata, 
    mem_wstrb, 
    mem_rdata
);
    input         clk;
    input         mem_valid;
    output reg        mem_ready;
    input  [11:0] mem_addr;
    input  [31:0] mem_wdata;
    input  [3:0]  mem_wstrb;
    output reg [31:0] mem_rdata;

    reg [31:0] memory[0:4095] /*synthesis syn_ramstyle = "block_ram"*/;

    initial
    begin
      $readmemh ("D:\Pico\picosoc_demo_1n9\src\ram.hex", memory);
    end  
  
    always @(posedge clk)
    begin
		mem_ready <= 0;
		if (mem_valid && !mem_ready) 
        begin
			if (mem_addr < 16384) 
            begin
				mem_ready <= 1;
				mem_rdata[ 7:0] <= memory[mem_addr >> 2][ 7:0];
				if (mem_wstrb[0]) 
                    memory[mem_addr >> 2][7:0] <= mem_wdata[ 7: 0];
			end
		end
    end
  
    always @(posedge clk)
    begin
		if (mem_valid && !mem_ready) 
        begin
			if (mem_addr < 16384) 
            begin
				mem_rdata[15:8] <= memory[mem_addr >> 2][15:8];
				if (mem_wstrb[1]) 
                    memory[mem_addr >> 2][15:8] <= mem_wdata[15:8];
			end
		end
    end

    always @(posedge clk)
    begin
		if (mem_valid && !mem_ready) 
        begin
			if (mem_addr < 16384) 
            begin
				mem_rdata[23:16] <= memory[mem_addr >> 2][23:16];
				if (mem_wstrb[2]) 
                    memory[mem_addr >> 2][23:16] <= mem_wdata[23:16];
			end
		end
    end
   
    always @(posedge clk)
    begin
		if (mem_valid && !mem_ready) 
        begin
			if (mem_addr < 16384) 
               begin
				mem_rdata[31:24] <= memory[mem_addr >> 2][31:24];
				if (mem_wstrb[3]) 
                    memory[mem_addr >> 2][31:24] <= mem_wdata[31:24];
			end
		end
    end
endmodule 









